<script setup>
import { ref, computed, h, watchEffect } from "vue";
import { escapeRegExpChars } from "@utils";
import Icon from "@components/Template/Icon.vue";

const props = defineProps({
  data: {
    type: Array,
    required: true,
  },
  filter: {
    type: String,
    default: "",
  },
  startDepth: {
    type: Number,
    default: 0,
  },
});

const flatItems = ref([]);
const filterRegex = ref(null);
const shouldUnfoldAll = computed(() => props.filter !== "");

watchEffect(() => {
  flatItems.value = props.data.map((path) => ({
    path,
    depth: path.split("/").length - 1,
  }));
  filterRegex.value = new RegExp(escapeRegExpChars(props.filter), "i");
});

const filteredItems = computed(() => {
  return flatItems.value.filter((item) => {
    if (props.startDepth > 0 && item.depth < props.startDepth) return false;
    return filterRegex.value.test(item.path);
  });
});

const filteredStructure = computed(() => {
  const structure = {};
  filteredItems.value.forEach((item) => {
    const parts = item.path.split("/");
    let current = structure;
    parts.forEach((part, index) => {
      if (index === parts.length - 1) {
        current[part] = item.path;
      } else {
        current[part] = current[part] || {};
        current = current[part];
      }
    });
  });
  return structure;
});

function onDragStart(event, path) {
  event.dataTransfer.setData("asset", path);
}

const FolderTree = {
  name: "FolderTree",
  props: ["structure", "filter", "level"],
  emits: ["drag-start"],
  setup(props, { emit }) {
    const isOpen = ref({});
    const originalIsOpen = ref({});
    const hasSavedOriginalState = ref(false);
    watchEffect(() => {
      if (props.filter !== "" && !hasSavedOriginalState.value) {
        // Save the current state on first filter change
        originalIsOpen.value = { ...isOpen.value };
        hasSavedOriginalState.value = true;
        // Unfold all
        Object.keys(props.structure).forEach((key) => {
          isOpen.value[key] = true;
        });
      } else if (props.filter === "" && hasSavedOriginalState.value) {
        // Restore the original state when filter becomes empty
        isOpen.value = { ...originalIsOpen.value };
        hasSavedOriginalState.value = false;
      }
    });
    const toggleFolder = (folder) => {
      if (props.filter === "") {
        isOpen.value[folder] = !isOpen.value[folder];
      }
    };
    return { isOpen, toggleFolder, emit };
  },
  render() {
    const level = this.level || 0;
    const renderTree = (structure, currentLevel) => {
      return h(
        "ul",
        { class: `folder-tree level-${currentLevel}` },
        Object.entries(structure).map(([key, value]) => {
          if (typeof value === "object") {
            return h("li", { key }, [
              h(
                "div",
                {
                  class: `folder level-${currentLevel} has-text-weight-semibold`,
                  onClick: () => this.toggleFolder(key),
                },
                [h(Icon, { icon: this.isOpen[key] ? "chevron-down" : "chevron-right" }), key],
              ),
              (this.isOpen[key] || shouldUnfoldAll.value) &&
                h(FolderTree, {
                  structure: value,
                  level: currentLevel + 1,
                  filter: this.filter,
                  onDragStart: (event, path) => this.emit("drag-start", event, path),
                }),
            ]);
          } else {
            return h(
              "li",
              { key },
              h(
                "div",
                {
                  class: [`file level-${currentLevel} tag is-medium is-grabbable ml-3 my-1 has-background-purple-5`],
                  draggable: true,
                  onDragstart: (event) => this.emit("drag-start", event, value),
                },
                key,
              ),
            );
          }
        }),
      );
    };

    return renderTree(this.structure, level);
  },
};
</script>

<template>
  <div class="folder-structure is-unselectable has-text-black">
    <folder-tree :structure="filteredStructure" :filter="filter" @drag-start="onDragStart" />
  </div>
</template>
